<?

# load models needed for this controller here
require_once DOCROOT.'/models/person.php';
require_once DOCROOT.'/models/XMLlib.php';

class personAjaxController extends C
{
	public function index()
	{
		//$this->redirect("/personAjax/list");
	}
	// list and new are keywords in php, so we append an underscore
	public function _list()
	{
		$this->new_person = new person();
		$this->people = person::getAll();
		$this->people = array_slice($this->people, 0, 10);
		switch ($this->responds_to)
		{
			case "xml":
				header("Content-type: text/xml"); 
				$this->render_text(XMLlib::toXML("people", $this->people));
				break;
			case "json":
				header('Content-Type: text/plain'); // plain text file
				$this->render_text(json_encode($this->people));
				break;
		}
	}
	public function _new()
	{
		switch ($this->responds_to)
		{
			case "ajax":
				$this->layout = false;
				$this->view_template = 'views/personAjax/new.ajax.php';
				break;
		}
	}
	public function create()
	{
	// collect POST variables here
	// save to database
	// redirect as appropriate
	/*$person = $_POST['person'];
	if (person::create($person))
	{
		setflash("Person created");
	}
	else
	{
		setflash("Could not create person");
	}*/
	setflash("Dummy create method called (".$_POST['person']['name'].")");
	$this->redirect('/personAjax/list');
	}
	public function show($id)
	{
		// $this->person = person::get($id);
		$this->person = person::getFakePerson();
		switch ($this->responds_to)
		{
			case "ajax":
				// perhaps the ajax view would be more detailed
				// you can pull in additional info needed for the ajax view here
				$this->person->college = 'Miami University';
				$this->person->major = 'Systems Analysis';
				$this->person->note = 'Decided on a major for seven years';
				$this->layout = false;
				$this->view_template = 'views/personAjax/show.ajax.php';
				break;
			case "xml":
				header("Content-type: text/xml"); 
				$this->render_text(XMLlib::objToXML($this->person));
				break;
			case "json":
				header('Content-Type: text/plain'); // plain text file
				$this->render_text(json_encode($this->person));
				break;
		}
	}
	public function destroy()
	{
		switch ($this->responds_to)
		{
			case "ajax":
				// simulates a failed call 50% of the time
				$this->result = rand(0,1);
				$this->layout = false;
				if ($this->result == 1)
				{
					$this->render_text($this->result."Destroy suceeded!");
				}
				else
				{
					$this->render_text($this->result."Destroy randomly fails 50% of the time for demonstration purposes");
				}
				break;
			default:
				setflash("Dummy destroy method called (#".$_GET['id'].")");
				$this->redirect("/person/list");
		}
	}
	public function edit($id)
	{
		$this->person = person::getFakePerson();
		$this->person->id = $id;
		switch ($this->responds_to)
		{
			case "ajax":
				$this->layout = false;
				$this->view_template = 'views/personAjax/edit.ajax.php';
			break;
		}
	}
	public function update()
	{
		$this->person = new person($_POST["person"]);
		$this->person->name = $this->person->name."*";
		switch ($this->responds_to)
		{
			case "ajax":
				// sometimes updates aren't successful.
				// Perhaps the user forgot to fill out a field
				// This update function succeeds 50% of the time.
				$this->result = rand(0,1);
				$this->layout = false;
				if ($this->result == 1)
				{
					$this->view_template = 'views/personAjax/update.success.php';
				}
				else
				{
					$this->render_text($this->result."Update randomly fails 50% of the time for demonstration purposes");
				}
				break;
			default:
				setflash("Dummy update method called (#".$_POST['person']['id'].")");
				$this->redirect('/personAjax/list');
		}
	}
	public function searchby()
	{
		$userinput = $_POST['queryString']; // sanitize this please!!!
		$this->partial_matches = person::searchby($userinput);
		$this->layout = false;
	}
}

?>
